octavia

octobanana's customizable text-based audio visualization interactive application.


octavia

/

RUNME.sh

1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39 40 41 42 43 44 45 46 47 48 49 50 51 52 53 54 55 56 57 58 59 60 61 62 63 64 65 66 67 68 69 70 71 72 73 74 75 76 77 78 79 80 81 82 83 84 85 86 87 88 89 90 91 92 93 94 95 96 97 98 99 100 101 102 103 104 105 106 107 108 109 110 111 112 113 114 115 116 117 118 119 120 121 122 123 124 125 126 127 128 129 130 131 132 133 134 135 136 137 138 139 140 141 142 143 144 145 146 147 148 149 150 151 152 153 154 155 156 157 158 159 160 161 162 163 164 165 166 167 168 169 170 171 172 173 174 175 176 177 178 179 180 181 182 183 184 185 186 187 188 189 190 191 192 193 194 195 196 197 198 199 200 201 202 203 204 205 206 207 208 209 210 211 212 213 214 215 216 217 218 219 220 221 222 223 224 225 226 227 228 229 230 231 232 233 234 235 236 237 238 239 240 241 242 243 244 245 246 247 248 249 250 251 252 253 254 255 256 257 258 259 260 261 262 263 264 265 266 267 268 269 270 271 272 273 274 275 276 277 278 279 280 281 282 283 284 285 286 287 288 289 290 291 292 293 294 295 296 297 298 299 300 301 302 303 304 305 306 307 308 309 310 311 312 313 314 315 316 317 318 319 320 321 322 323 324 325 326 327 328 329 330 331 332 333 334 335 336 337 338 339 340 341 342 343 344 345 346 347 348 349 350 351 352 353 354 355 356 357 358 359 360 361 362 363 364 365 366 367 368 369 370 371 372 373 374 375 376 377 378 379 380 381 382 383 384
#!/usr/bin/env bash
:<<'####'
                                    88888888
                                  888888888888
                                 88888888888888
                                8888888888888888
                               888888888888888888
                              888888  8888  888888
                              88888    88    88888
                              888888  8888  888888
                              88888888888888888888
                              88888888888888888888
                             8888888888888888888888
                          8888888888888888888888888888
                        88888888888888888888888888888888
                              88888888888888888888
                            888888888888888888888888
                           888888  8888888888  888888
                           888     8888  8888     888
                                   888    888

                                   OCTOBANANA

Licensed under the MIT License

Copyright (c) 2019 Brett Robinson <https://octobanana.com/>

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all
copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
SOFTWARE.
####

set -e

SELF="${0##*/}"
SUB_COMMAND=""
BUILD_TYPE=""

usage() {
  if [[ "${SUB_COMMAND}" == "clean" ]]; then
    printf "Usage:\n"
    printf "  ./%s clean [--release|--debug]\n" "${SELF}"
  elif [[ "${SUB_COMMAND}" == "dev" ]]; then
    printf "Usage:\n"
    printf "  ./%s dev [--release|--debug] [-- <args>]\n" "${SELF}"
  elif [[ "${SUB_COMMAND}" == "build" ]]; then
    printf "Usage:\n"
    printf "  ./%s build [--release|--debug] [-- <args>]\n" "${SELF}"
  elif [[ "${SUB_COMMAND}" == "install" ]]; then
    printf "Usage:\n"
    printf "  ./%s install [--release|--debug] [-- <args>]\n" "${SELF}"
  else
    printf "Usage:\n"
    printf "  ./%s --help\n" "${SELF}"
    printf "  ./%s clean [--release|--debug]\n" "${SELF}"
    printf "  ./%s dev [--release|--debug] [-- <args>]\n" "${SELF}"
    printf "  ./%s build [--release|--debug] [-- <args>]\n" "${SELF}"
    printf "  ./%s install [--release|--debug] [-- <args>]\n" "${SELF}"
    printf "\n"
    printf "Examples:\n"
    printf "  ./%s build --release -- -DCMAKE_CXX_COMPILER='clang++'\n" "${SELF}"
    printf "  ./%s install --release\n" "${SELF}"
  fi

  if [[ "${*}" != "" ]] ; then
    printf "\nError: %s\n" "${*}"
  fi
}

is_project_root() {
  if ! [[ -e ./.gitignore ]]; then
    usage "not in project root"
    exit 1
  fi
}

on_clean() {
  while [[ "${#}" -gt 0 ]]; do case "${1}" in
    -r|--release)
      BUILD_TYPE="release"
      shift
      ;;
    -d|--debug)
      BUILD_TYPE="debug"
      shift
      ;;
    -h|--help)
      usage
      exit
      ;;
    *)
      usage "invalid argument '${1}'"
      exit 1
      ;;
    esac
  done

  do_clean "${@}"
}

do_clean() {
  rm -rf ./build/"${BUILD_TYPE}" ./.m8 ./m8
}

on_dev() {
  BUILD_TYPE="debug"

  while [[ "${#}" -gt 0 ]]; do case "${1}" in
    -r|--release)
      BUILD_TYPE="release"
      shift
      ;;
    -d|--debug)
      BUILD_TYPE="debug"
      shift
      ;;
    -h|--help)
      usage
      exit
      ;;
    --)
      shift
      break
      ;;
    *)
      usage "invalid argument '${1}'"
      exit 1
      ;;
    esac
  done

  do_dev "${@}"
}

print_status() {
  printf "\n"
  if [[ "${1}" -eq 0 ]]; then
    if [[ "${2}" -ne 0 ]]; then
      hr -b reverse -f green-bright -s 'PASS '
    else
      hr -b reverse -f green-bright -s 'PASS '
    fi
  else
    hr -b reverse -f red-bright -s 'FAIL '
  fi
  printf "\n"
}

do_dev() {
  set +e

  # log files
  # log_base="./build/debug/log"
  # log_build="${log_base}/build.log"
  # log_error="${log_base}/error.log"
  # log_warning="${log_base}/warning.log"
  log_base="./log"
  log_build="${log_base}/build.log"
  log_error="${log_base}/error.log"
  log_warning="${log_base}/warning.log"
  mkdir -p ./build/"${BUILD_TYPE}"
  cd ./build/"${BUILD_TYPE}"

  # setup
  # rm -rf ./.m8 ./m8
  # ln -s ./dev/m8 ./m8

  # create log directory
  mkdir -p "${log_base}"

  # clear log files
  :> "${log_build}"
  :> "${log_error}"
  :> "${log_warning}"

  cmake ../../ -DCMAKE_BUILD_TYPE="${BUILD_TYPE}" "${@}"
  time unbuffer make -j $(( 2 * $(nproc --all) )) 2>&1 | tee "${log_build}"

  # make
  # time unbuffer make -f ./dev/makefile -j $(( 2 * $(nproc --all) )) BUILD_TYPE="${BUILD_TYPE}" "${@}" 2>&1 | tee "${log_build}"

  # preserve make exit status
  STATUS="${PIPESTATUS[0]}"

  # cleanup
  # rm -rf ./.m8 ./m8

  # print horizontal rule
  hr

  # write warnings and errors to log files
  printf "%s" "$(grep -Ei 'warning:' ${log_build})" > "${log_warning}"
  printf "%s" "$(grep -Ei 'error:' ${log_build})" > "${log_error}"

  # get number of warnings
  NUM_WARN=$(grep -Eic 'warning:' "${log_build}")

  # print warnings
  if [[ "${NUM_WARN}" -ne 0 ]]; then
    printf "\nWarnings: %s\n" "${NUM_WARN}"
    printf "%s\n" "$(grep -Eo ' \[.*?(\-W.*?).*?\]' "${log_build}"\
      | cut -c1- | sort | uniq -c | sort -nr)"
    printf "\n"
  fi

  # print errors
  if [[ "${STATUS}" -ne 0 ]]; then
    printf "%s\n" "$(grep -Ei 'error:' ${log_build})"
    printf "\nErrors: %s\n\n" "$(grep -Eic 'error:' ${log_build})"
  fi

  # print date
  date

  # print status
  print_status "${STATUS}" "${NUM_WARN}"

  # return make exit status
  exit "${STATUS}"
}

on_build() {
  BUILD_TYPE="release"

  while [[ "${#}" -gt 0 ]]; do case "${1}" in
    -r|--release)
      BUILD_TYPE="release"
      shift
      ;;
    -d|--debug)
      BUILD_TYPE="debug"
      shift
      ;;
    -h|--help)
      usage
      exit
      ;;
    --)
      shift
      break
      ;;
    *)
      usage "invalid argument '${1}'"
      exit 1
      ;;
    esac
  done

  do_build "${@}"
}

do_build() {
  printf "Build type: %s\n" "${BUILD_TYPE}"
  mkdir -p ./build/"${BUILD_TYPE}"
  cd ./build/"${BUILD_TYPE}"
  cmake ../../ -DCMAKE_BUILD_TYPE="${BUILD_TYPE}" "${@}"

  if [[ "${BUILD_TYPE}" == "release" ]]; then
    make -j2
  elif [[ "${BUILD_TYPE}" == "debug" ]]; then
    time make -j2
  fi

  cd ../../
}

on_install() {
  BUILD_TYPE="release"

  while [[ "${#}" -gt 0 ]]; do case "${1}" in
    -r|--release)
      BUILD_TYPE="release"
      shift
      ;;
    -d|--debug)
      BUILD_TYPE="debug"
      shift
      ;;
    -h|--help)
      usage
      exit
      ;;
    --)
      shift
      break
      ;;
    *)
      usage "invalid argument '${1}'"
      exit 1
      ;;
    esac
  done

  do_install "${@}"
}

do_install() {
  if [[ "${SUB_COMMAND}" != "build" ]]; then
    do_build "${@}"
  fi

  cd ./build/"${BUILD_TYPE}"
  set +e
  OUTPUT="$(make install 2>&1)"
  OUTPUT_STATUS="${?}"
  set -e

  if [[ "${OUTPUT_STATUS}" -ne 0 ]]; then
    if command -v sudo > /dev/null; then
      sudo make install
    elif command -v doas > /dev/null; then
      doas make install
    else
      printf "Error: unable to elevate privileges, tried 'sudo' and 'doas'\n"
      exit 1
    fi
  else
    printf "%s\n" "${OUTPUT}"
  fi

  cd ../../
}

on_normal() {
  while [[ "${#}" -gt 0 ]]; do case "${1}" in
    -h|--help)
      usage
      exit
      ;;
    *)
      usage "invalid argument '${1}'"
      exit 1
      ;;
    esac
  done
}

subcommand() {
  if [[ "${#}" -gt 0 ]]; then
    if [[ "${1}" == "c" || "${1}" == "clean" ]]; then
      SUB_COMMAND="clean"
      shift
      on_clean "${@}"
    elif [[ "${1}" == "d" || "${1}" == "dev" ]]; then
      SUB_COMMAND="dev"
      shift
      on_dev "${@}"
    elif [[ "${1}" == "b" || "${1}" == "build" ]]; then
      SUB_COMMAND="build"
      shift
      on_build "${@}"
    elif [[ "${1}" == "i" || "${1}" == "install" ]]; then
      SUB_COMMAND="install"
      shift
      on_install "${@}"
    else
      on_normal "${@}"
    fi
  else
    usage "expected subcommand and/or arguments"
    exit 1
  fi
}

main() {
  is_project_root
  subcommand "${@}"
}

main "${@}"
Back to Top